package io.gmss.fiscad.implementations.rfu.metier;

import io.gmss.fiscad.entities.rfu.metier.EnqueteUniteLogement;
import io.gmss.fiscad.exceptions.BadRequestException;
import io.gmss.fiscad.exceptions.NotFoundException;
import io.gmss.fiscad.interfaces.rfu.metier.EnqueteUniteLogementService;
import io.gmss.fiscad.repositories.rfu.metier.EnqueteUniteLogementRepository;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

@Service
public class EnqueteUniteLogementServiceImpl implements EnqueteUniteLogementService {

    private final EnqueteUniteLogementRepository enqueteUniteLogementRepository;

    public EnqueteUniteLogementServiceImpl(EnqueteUniteLogementRepository enqueteUniteLogementRepository) {
        this.enqueteUniteLogementRepository = enqueteUniteLogementRepository;
    }

    @Override
    public EnqueteUniteLogement createEnqueteUniteLogement(EnqueteUniteLogement enqueteUniteLogement) throws BadRequestException {
        if (enqueteUniteLogement.getId() != null) {
            throw new BadRequestException("Impossible de créer une nouvelle enquete de d'unité de logement ayant un id non null.");
        }
        return enqueteUniteLogementRepository.save(enqueteUniteLogement);
    }

    @Override
    public EnqueteUniteLogement updateEnqueteUniteLogement(Long id, EnqueteUniteLogement enqueteUniteLogement) throws NotFoundException {
        if (enqueteUniteLogement.getId() == null) {
            throw new BadRequestException("Impossible de mettre à jour une nouvelle enquete d'unité de logement ayant un id null.");
        }
        if (!enqueteUniteLogementRepository.existsById(enqueteUniteLogement.getId())) {
            throw new NotFoundException("Impossible de trouver la nouvelle enquete d'unité de logement spécifiée dans notre base de données.");
        }
        return enqueteUniteLogementRepository.save(enqueteUniteLogement);
    }

    @Override
    public void deleteEnqueteUniteLogement(Long id) throws NotFoundException {
        Optional<EnqueteUniteLogement> enqueteUniteLogementOptional = enqueteUniteLogementRepository.findById(id);
        if (enqueteUniteLogementOptional.isPresent()) {
            enqueteUniteLogementRepository.deleteById(enqueteUniteLogementOptional.get().getId());
        } else {
            throw new NotFoundException("Impossible de trouver la nouvelle enquete d'unité de logement spécifiée dans notre base de données.");
        }
    }

    @Override
    public Page<EnqueteUniteLogement> getEnqueteUniteLogementList(Pageable pageable) {
        return enqueteUniteLogementRepository.findAll(pageable);
    }

    @Override
    public List<EnqueteUniteLogement> getEnqueteUniteLogementList() {
        return enqueteUniteLogementRepository.findAll();
    }


    @Override
    public Optional<EnqueteUniteLogement> getEnqueteUniteLogementById(Long id) {
        if (enqueteUniteLogementRepository.existsById(id)) {
            return enqueteUniteLogementRepository.findById(id);
        } else {
            throw new NotFoundException("Impossible de trouver la nouvelle enquete d'unité de logement spécifiée dans la base de données.");
        }

    }
}
